Distributed File System (DFS)

Microsoft Windows graphic

Distributed File System

This topic describes Distributed File System (DFS) and how to administer it.

  • Before creating a distributed file system, see Checklist: Creating a distributed file system.
  • For recommendations on implementing DFS, see Best practices.
  • For help with specific tasks, see How to.
  • For general background information, see Concepts.


Checklist: Creating a distributed file system

Step | Reference
Review distributed file system concepts | Concepts
Create a DFS root for a distributed file system | To create a DFS root
(Optional) If using a domain DFS root, add a root target | To add a root target
Add a DFS link to a distributed file system | To add a DFS link
Add targets to a DFS link | To add a target
(Optional) Configure replication for targets | Configure replication
Manage security on shared folders used by DFS | Securing shared resources


Best practices

  • Use DFS with the NTFS file system only.

    • Do not install DFS on a FAT file system. DFS on the Windows Server 2003 family can only be used with the NTFS file system. For information on converting a volume to NTFS, see Convert.

  • Set the replication policy.

    • To maintain a balanced load on your server, you should consider the schedule of synchronization. This requires that you understand the following:

    • The topology between the participating servers.
    • How network performance may be impacted, based on available bandwidth.
    • The quantity of replication traffic likely to occur.
    • Replication schedules for the distributed file system, as well as the replication schedules for any other distributed file systems in the same site.

    Automatic file replication through the File Replication service (FRS) is only available with domain DFS.

  • Do not create FRS replica sets on a volume that is managed by Remote Storage.

    • Doing so might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

  • Perform regular administration as follows:

    • After you have created a DFS console for the DFS roots that you administer, save the console file for future use.

    Periodically, perform a status check on common targets to ensure that the targets are still accessible.

  • Ensure that file system permissions are set correctly.

    • In order for a user to access files in a DFS target folder, the user must be allowed access to the target and to all parent folders. In addition, the user must be allowed access to the server hosting the DFS root, and to the link and the link's parent folders. For more information on setting permissions, see Access control overview.

  • Monitor anti-virus or defragmentation software carefully.

    • Anti-virus and defragmentation software can interfere with successful file replication. If you are running anti-virus or defragmentation software on any of the computers that host your domain DFS root or targets, disable it or monitor it carefully until initial file replication is complete.

  • Consider the needs of your users.

    • Include commonly-used network shares in your DFS namespace.

    For links that point to targets with content that frequently changes,use a shorter cache time-out value to ensure that clients maintain an updated list of targets.


How to...

  • Create a DFS root
  • Add a DFS root target
  • Show a DFS root
  • Add a DFS link
  • Filter the DFS link display
  • Enable or disable DFS referral
  • Add a target
  • Check status of a DFS root, DFS link, or target
  • Hide a DFS root
  • Delete a DFS root, root target, link, or target
  • Configure replication


Create a DFS root

Microsoft Windows graphic

To create a DFS root

  1. Open Distributed File System.
  2. On the Action menu, click New Root.
  3. Follow the instructions that appear in the New Root wizard.

Notes

  • In order to make changes to an existing DFS namespace, you must be a member of the Administrators group on the server hosting the namespace. As a security best practice, consider using Run as to perform this procedure.
  • XOX
  • If the folder that you specify to correspond to the root does not exist, or has not been shared, you will be prompted to create a new shared folder. You can then type the name of a new folder, or type the name of an existing folder that has not yet been shared. DFS will create the folder (if necessary), then share the folder.
  • You can host multiple DFS roots on a single computer when using XOX, or XOX.
  • On server clusters, the name you give a non-clustered DFS root on a node's local storage must be different from the name you give a clustered DFS root on the cluster storage.
  • To remove a root, select the root, open the Action menu, and click Delete Root.
  • Any member server or domain controller can host a DFS root. You must have be a member of the Administrators group on a server to create a DFS root on that server. In addition, you need domain administrator credentials to create a domain root.
  • If your DFS namespace includes roots and root targets which exist on both computers running one of the Windows Server 2003 family of products and computers running Windows 2000, you must administer those roots from a computer running a product in the Windows Server 2003 family, or from a computer running the Windows Server 2003 Administration Tools Pack. You can not administer the DFS namespace from a computer running Windows 2000.
  • Only NTFS volumes can host DFS roots. You cannot host a DFS root on a FAT or FAT32 partition.
  • When working with shared folders, use NTFS and file sharing permissions to secure the folder and any subfolders so that only authorized users can access them.

Related Topics


Add a DFS root target

Microsoft Windows graphic

To add a DFS root target

  1. Open Distributed File System.
  2. Select the domain root for which you want to add a root target.
  3. On the Action menu, click New Root Target.
  4. Follow the instructions that appear in the New Root wizard.

Notes

  • In order to make changes to an existing DFS namespace, you must be a member of the Administrators group on the server hosting the namespace. As a security best practice, consider using Run as to perform this procedure. You must be a member of the Administrators group on a server to create a root target on that server.
  • XOX
  • To remove a root target, select the root target, open the Action menu, and click Remove Target.
  • You can only add root targets to domain DFS roots.
  • If the folder that you specify to correspond to the root target does not exist or has not been shared, you will be prompted to create a new shared file. You can then type the name of a new folder, or type the name of an existing folder that has not yet been shared. DFS will create the folder (if necessary), then share the folder. Be aware that although the name of the folder itself does not have to be the same as the root, the folder will automatically be shared with the same name as the root.
  • If you add a shared folder on a Windows 2000 computer as a root target, it may not display in the list of root targets immediately.
  • If your DFS namespace includes roots and root targets which exist on both computers running one of the Windows Server 2003 family of products and computers running Windows 2000, you must administer those roots from a computer running a product in the Windows Server 2003 family, or from a computer running the Windows Server 2003 Administration Tools Pack. You can not administer the DFS namespace from a computer running Windows 2000.
  • When working with shared folders, use NTFS and file sharing permissions to secure the folder and any subfolders so that only authorized users can access them.

Related Topics


Show a DFS root

Microsoft Windows graphic

To show a DFS root

  1. Open Distributed File System.
  2. Click Distributed File System.
  3. On the Action menu, click Show Root.
  4. In the Root or host server field, type in the UNC name for an existing DFS root, or expand the list of trusting domains and click the DFS root, then click OK.

Notes

  • XOX
  • XOX
  • To specify the DFS root, you can type either \\HostDomain\DFSRootName or \\HostServer\DFSRootName, where HostDomain is the name of the domain on which the root resides (for domain DFS), HostServer is the name of the server on which the root resides (for stand-alone DFS), and DFSRootName is the name of the root.
  • You can also show a root by typing the name of the host server alone. If the host server has a single root, DFS will show the root. If the host server has multiple roots, DFS will display a list of all the roots on the server and allow you to pick the root or roots to display. You can select more than one root by holding down the SHIFT or CTRL keys as you click.


Add a DFS link

Microsoft Windows graphic

To add a DFS link

  1. Open Distributed File System.
  2. In the console tree, click the DFS root.
  3. On the Action menu, click New Link.
  4. Type a name for the new link.
  5. Type a path for the new link or click Browse to select from the list of available shared folders.
  6. Type a comment, if you would like to use it to further identify or describe the link.
  7. Type the duration for which a reference to this link will be cached on a DFS client, then click OK.

Notes

  • In order to make changes to an existing DFS namespace, you must be a member of the Administrators group on the server hosting the namespace. As a security best practice, consider using Run as to perform this procedure.
  • XOX
  • The folder that you specify as the target must be an existing shared folder.
  • To delete a link, select the link, open the Action menu, and click Delete Link.
  • If you later delete a target from this link using dfscmd /remove on the command line, you must specify the same name you used to create the link. For example, if you create the link using its DNS name, you must specify the DNS name when using dfscmd, rather than the NetBIOS name. Consider using a consistent naming standard when adding links, so it will be easier to remember later.
  • When working with shared folders, use NTFS and file sharing permissions to secure the folder and any subfolders so that only authorized users can access them.

Related Topics


Filter the DFS link display

Microsoft Windows graphic

To filter the DFS link display

  1. Open Distributed File System.
  2. In the console tree, click the DFS root.
  3. On the Action menu, click Filter Links.
  4. In the Type the maximum number of links box, type the maximum number of links to display in the console tree.
  5. Select Filter links by name, and then do one of the following:
    • To display all links with names starting with a certain text string, select Starts with in the list box, and then type the text string on which you would like to filter.
    • To display all links with names containing a certain text string, select Contains in the list box, and then type the text string on which you want to filter.

Notes

  • XOX
  • XOX
  • To display all DFS links, type a number greater than or equal to the total number of existing links in the Type the maximum number of links box, and select Do not filter links by name.

Related Topics


Enable or disable DFS referral

Microsoft Windows Graphic

To enable or disable DFS referral

  1. Open Distributed File System.
  2. In the console tree, click the DFS link that points to the target for which you would like to change the referral status.
  3. Click the desired target. On the Action menu, select Enable or Disable Referral.

Notes

  • In order to make changes to an existing DFS namespace, you must be a member of the Administrators group on the server hosting the namespace. As a security best practice, consider using Run as to perform this procedure.
  • XOX
  • When you disable DFS referral for a target, DFS will not direct users to the target folder until DFS referral is enabled.
  • If DFS referral is enabled for a target, selecting Enable or Disable Referral will disable it. If DFS referral is disabled, the action will enable it.
  • The DFS Referral column and Status column in the details pane provide information about the referral status of each target. The DFS Referral column indicates if DFS referral is enabled and the Status column indicates if a particular target is available. If a target can not accessed, the Status column will read Offline. To see the current status for a target, click it and select Check Status from the Action menu.
  • When working with shared folders, use NTFS and file sharing permissions to secure the folder and any subfolders so that only authorized users can access them.

Related Topics


Add a target

Microsoft Windows graphic

To add a target

  1. Open Distributed File System.
  2. In the console tree, click the DFS link to which you want to assign a target.
  3. On the Action menu, click New Target.
  4. Under Path to target (shared folder), enter the name of a shared folder, or click Browse to select from the list of available shared folders.
  5. If you are adding the target to a domain root, click Add this target to the replication set to enable automatic file replication for the target.
  6. If you are not enabling automatic file replication, you must manually copy files to the new target from other targets.

Notes

  • In order to make changes to an existing DFS namespace, you must be a member of the Administrators group on the server hosting the namespace. As a security best practice, consider using Run as to perform this procedure.
  • XOX
  • The folder that you specify as the target must be an existing shared folder.
  • To remove a target, select the target, open the Action menu, and click Remove Target.
  • This procedure for adding a target should not be used for adding the first target. The first target is added when you create the DFS link.
  • If a link points to another domain DFS, it cannot point to any other targets. To add a target in this case, you must add it to the targeted DFS and not to the link itself.
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • When working with shared folders, use NTFS and file sharing permissions to secure the folder and any subfolders so that only authorized users can access them.

Related Topics


Check status of a DFS root, DFS link, or target

Microsoft Windows graphic

To check status of a DFS root, DFS link, or target

  1. Open Distributed File System.
  2. In the DFS administration tool, click the DFS root, DFS link, or target whose status you want to check.
  3. On the Action menu, click Check Status.

Notes

  • XOX
  • XOX

Related Topics


Hide a DFS root

Microsoft Windows graphic

To hide a DFS root

  1. Open Distributed File System.
  2. In the console tree, click the DFS root.
  3. On the Action menu, click Hide Root.
  4. A dialog box will appear, asking if you want to hide the root. Click Yes.

Notes

  • XOX
  • XOX
  • The root is removed from the DFS administration tool. The distributed file system itself is not affected. User access to the root is not affected by this procedure.


Delete a DFS root, root target, link, or target

Microsoft Windows Graphic

To delete a DFS root, root target, link, or target

  1. Open Distributed File System.
  2. Click the DFS root, root target, link, or target that you want to delete. You might have to navigate through the console tree to reveal the object you would like to delete.
  3. On the Action menu, click Delete Root, Delete Link, or Remove Target, depending on the nature of the object you would like to delete.
  4. A dialog box will appear asking you for confirmation. Click Yes.

Important

  • Deleting a root is not a recoverable operation. Deleting a root removes the root from the administration tool and removes the entire DFS structure associated with the root, but does not delete any data. If it is a stand-alone root, the procedure removes the DFS configuration data from the host computer. If it is a domain root, the procedure removes the configuration data from each host computer and from Active Directory.
  • Deleting a root, root target, link, or target does not delete any associated shared folders from the file system, and it does not change any permissions associated with files or folders. If you no longer want users to have access to data in these shared folders, use NTFS or file sharing permissions to restrict access.

Notes

  • In order to make changes to an existing DFS namespace, you must be a member of the Administrators group on the server hosting the namespace. As a security best practice, consider using Run as to perform this procedure.
  • XOX
  • If you remove the only target of a link, the link will be deleted.

Related Topics


Configure replication

  • View replication properties
  • Initiate file replication
  • Show or hide replication information for a list of targets
  • Enable or disable replication for a target
  • Modify replication topology
  • Set the replication schedule
  • Exclude files or subfolders from replication
  • Remove files or subfolders from the exclusion list


View replication properties

Microsoft Windows Graphic

To view replication properties

  1. Open Distributed File System.
  2. Click the domain DFS root or link for which replication has been configured.
  3. On the Action menu, click Properties.
  4. Click the Replication tab.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • This procedure is applicable only after you have initiated replication.
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • From here, you can view and change the replication topology, view and change the replication schedule, and exclude files and subfolders from replication.

Related Topics


Initiate file replication

Microsoft Windows Graphic

To initiate file replication

  1. Open Distributed File System.
  2. Click the domain root or link for which you would like to initiate replication.
  3. On the Action menu, select Configure Replication.
  4. Follow the instructions that appear in the Configure Replication wizard.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

  • Do not enable replication on Distributed File System (DFS) roots.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • A domain DFS root or link must have at least two targets before you can begin replication.
  • To stop replication on a link, click the link, click the Action menu, and then click Stop Replication.

Related Topics


Show or hide replication information for a list of targets

Microsoft Windows Graphic

To show or hide replication information for a list of targets

  1. Open Distributed File System.
  2. Click the DFS link for which you want to display or hide replication information.
  3. On the Action menu, click Show Replication Information (if the "File Replication" column is currently hidden and you want to display it) or Hide Replication Information (if the "File Replication" column is currently visible and you want to hide it).

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • The "File Replication" column shows whether each individual target participates in replication.

Related Topics


Enable or disable replication for a target

Microsoft Windows Graphic

To enable or disable replication for a target

  1. Open Distributed File System.
  2. Click the DFS link for which you want to manage replication.
  3. If the "File Replication" column is not visible in the list of targets, display it by clicking the Action menu and clicking Show Replication Information.
  4. Click the target for which you would like to change the replication status.
  5. On the Action menu, click Enable Replication (if replication is currently disabled and you want to enable it) or Disable Replication (if replication is currently enabled and you want to disable it).

    If you are enabling replication for the target, you will be prompted to designate a staging folder.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • You cannot disable replication on a target that is serving as the hub in a hub-and-spoke replication system without first designating a different target as a hub.

Related Topics


Modify replication topology

Microsoft Windows Graphic

To modify replication topology

  1. Open Distributed File System.
  2. Click the root or link for which you want to manage replication.
  3. On the Action menu, click Properties.
  4. On the Replication tab, click the Customize button.
  5. In the Topology drop-down list, click the type of replication topology you want to use. A list of server connections will appear under Connections.
  6. Under Connections, select or clear the check boxes to enable or disable replication connections between servers.
  7. If you choose a custom topology, you must add and delete connections manually. To add a connection, click the New button, or, to delete an existing connection, click Delete.
  8. To change the synchronization priority for initial synchronization or restores, click the Priorities button.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • The Replication tab is only available for domain DFS roots or links for which you have already configured replication.

Related Topics


Set the replication schedule

Microsoft Windows Graphic

To set the replication schedule

  1. Open Distributed File System.
  2. Click the domain DFS root or link for which you want to manage replication. On the Action menu, click Properties.
  3. On the Replication tab, click Schedule. The replication schedule appears, with blue representing the times when replication is available, and white representing the times when replication is not available.
  4. On the replication schedule, click to select an hour or drag to select a range of hours.
  5. Enable or disable replication for the selected time period or periods as follows:
    • To enable replication, click Replication Available.
    • To disable replication, click Replication Not Available
  6. Repeat the previous two steps as necessary, then click OK.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • Clicking on the name of a day of the week will select the entire day. Clicking directly underneath an hour label will select that hour every day. Clicking All will select the entire schedule.
  • This method allows you to set the schedule for all existing connections. To set the schedule for individual connections, on the Replication tab, click Customize, select the connection or connections for which you would like to change the schedule, and click Schedule.
  • Modifying the schedule for all existing connections will override any changes you have made to the schedule for individual connections.
  • To override the replication schedule for the initial synchronization of inbound connections and during file restoration operations, on the Replication tab, click Customize, click Priorities and then check the Override Schedule check box for the appropriate inbound connection.

Related Topics


Exclude files or subfolders from replication

Microsoft Windows Graphic

To exclude files or subfolders from replication

  1. Open Distributed File System.
  2. Click the domain DFS root or link for which you want to manage replication. On the Action menu, click Properties.
  3. On the Replication tab, next to File filter (for files) or Subfolder filter (for subfolders), click Edit.
  4. Type the name of a file or subfolder you want to exclude from replication.
  5. Click Add to add the file or folder name to the exclusion list, and then click OK.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.
  • When typing the file or folder name to exclude from replication, you can use the asterisk (*) or the question mark (?) as wildcard characters. For example, *.tmp matches all files with the .tmp extension.

Related Topics


Remove files or subfolders from the exclusion list

Microsoft Windows Graphic

To remove files or subfolders from the exclusion list

  1. Open Distributed File System.
  2. Click the domain DFS root or link for which you want to manage replication. On the Action menu, click Properties.
  3. On the Replication tab, next to File filter or Subfolder filter, click Edit.
  4. Click the file or folder name or specification you would like to remove from the list.
  5. Click Remove to remove the item from the exclusion list, and then click OK.

Caution

  • Do not create File Replication service (FRS) replica sets on a volume that is managed by Remote Storage. Otherwise you might severely impact system performance and possibly cause data loss within your media library.

    FRS might need to periodically read every file in the replica set to send the file contents to another computer. This causes FRS to recall all files that Remote Storage has sent to secondary storage, which might take a long time (hours or days). If you use tape for your secondary storage, remember FRS recalls files in directory order rather than media order, so the excessive number of tape seeks performed by FRS will likely ruin the tapes and cause data loss.

Notes

  • XOX
  • XOX
  • Automatic file replication through the File Replication service is only available with domain DFS.

Related Topics


Concepts

This section covers:

  • Distributed file system overview
  • Understanding Distributed File System
  • Using Distributed File System


Distributed File System overview

With Distributed File System (DFS), system administrators can make it easy for users to access and manage files that are physically distributed across a network. With DFS, you can make files distributed across multiple servers appear to users as if they reside in one place on the network. Users no longer need to know and specify the actual physical location of files in order to access them.

For example, if you have marketing material scattered across multiple servers in a domain, you can use DFS to make it appear as though all of the material resides on a single server. This eliminates the need for users to go to multiple locations on the network to find the information they need.

Reasons for using DFS

You should consider implementing DFS if:

  • You expect to add file servers or modify file locations.
  • Users who access targets are distributed across a site or sites.
  • Most users require access to multiple targets.
  • Server load balancing could be improved by redistributing targets.
  • Users require uninterrupted access to targets.
  • Your organization has Web sites for either internal or external use.

DFS types

You can implement a distributed file system in either of two ways, either as a stand-alone root distributed file system, or as a domain distributed file system.

Accessing DFS targets from other computers

In addition to the server-based DFS component of the Windows Server 2003 family, there is a client-based DFS component. The DFS client caches a referral to a DFS root or a DFS link for a specific length of time, defined by the administrator.

The DFS client component runs on a number of different Windows platforms. For information on DFS client versions and their associated platforms, see Platform compatibility.

For more information, see Understanding Distributed File System and Using Distributed File System.


Understanding Distributed File System

This section covers:

  • Distributed File System features
  • Distributed File System mapping
  • Distributed File System and security
  • Platform compatibility


Distributed File System features

The Distributed File System (DFS) provides several important features, described in the following sections.

Easy access to files

A distributed file system makes it easier for users to access files. Users need only go to one location on the network to access files, even though the files may be physically spread across multiple servers.

Also, when you change the physical location of a target, user access to the folder is not impacted. They still access the folder in the same way as before, because the location of the file looks the same.

Users no longer need multiple drive mappings to access their files.

Finally, scheduled file server maintenance, software upgrades and other tasks that normally require taking the server offline can be accomplished without disrupting user access. This is particularly useful for Web servers. By selecting the root for the Web site as a DFS root, you can move resources within the distributed file system without breaking any HTML links.

Availability

Domain DFS ensures that users retain access to their files, in two ways:

First, the Windows Server 2003 operating system automatically publishes the DFS mapping to Active Directory. This ensures that the DFS namespace is always visible to users on all servers in the domain.

Second, as an administrator, you can replicate your DFS roots and your targets. Replication means that you can duplicate DFS roots and targets on multiple servers in the domain. In this way, users can still access their files, even if one of the physical servers on which those files reside becomes unavailable.

Server load balancing

A DFS root can support multiple targets that are physically distributed across a network. This is useful, for example, if you have a file that you know will be accessed heavily by your users. Rather than all users physically accessing this file on a single server, and thus taxing the server, DFS ensures that user access to the file is distributed to multiple servers. To users, however, the file resides in one location on the network.

File and folder security

Because the shared resources DFS manages use standard NTFS and file sharing permissions, you can use preexisting security groups and user accounts to ensure that only authorized users have access to sensitive data.


Distributed File System mapping

A Distributed File System (DFS) mapping consists of a DFS root, one or more DFS links, and referrals to one or more targets.

The domain server on which a DFS root resides is known as a host server. You can replicate a DFS root by creating root targets on other servers in the domain. This provides file availability when the host server becomes unavailable.

To users, a DFS mapping provides unified and transparent access to the network resources they need. To system administrators, a DFS mapping is a single DNS namespace: With domain DFS, the DNS names for the DFS root targets resolve to the host servers for the DFS root.

Because the host server for a domain distributed file system is a member server within a domain, the DFS mapping is automatically published to Active Directory by default, thus providing synchronization of DFS topologies across host servers. This, in turn, provides fault tolerance for the DFS root and supports optional replication of targets.

You can expand a DFS mapping by adding a DFS link to the DFS root. The only constraint on the number of hierarchical levels in a DFS mapping is imposed by the Windows Server 2003 family limit of 260 characters for any file path. A new DFS link can refer to a target with or without subfolders, or to an entire Windows Server 2003 family volume. If you have adequate permissions, you can also access any local subfolders that exist in or are added to a target.


Distributed File System and security

Aside from granting the necessary permissions, Distributed File System (DFS) service does not implement any additional security measures, beyond what the Windows Server 2003 family system provides. The permissions assigned to a DFS root or DFS link determine who can add a new DFS link.

Permissions to a target are not related to the DFS topology. For example, suppose there is a DFS link named MarketingDocs and you have appropriate permissions to access a particular target to which MarketingDocs points. In this case, you can then access all other targets in the set of targets, regardless of whether or not you have permissions to access those other targets. However, having permission to access these targets does determine whether or not you have access to any of the information within the targets. Such access is determined by standard Windows Server 2003 family security controls.

In summary, security is enforced by the underlying file system when a user tries to access a target and its contents. Thus, a FAT volume provides share-level security on files, while an NTFS volume provides full Windows Server 2003 family security. To maintain security, you should use NTFS and file sharing permissions to secure any shared folders used by DFS so that only authorized users can access them.

For more information on setting permissions, see Securing shared resources. For security recommendations for DFS, see Best practices.


Platform compatibility

The Windows Server 2003 family supports targets on the following platforms.

Platform | Host DFS Client | Host DFS Root
MS-DOS, Windows 3.x, Windows for Workgroups, and NetWare servers | No | No
Windows 95 | Yes, download client | No
Windows 98 | Yes, stand-alone client included; download client for domain | No
Windows NT 4.0 and Service Pack 3 | Yes, stand-alone client included | Yes, stand-alone root DFS only
Windows 2000 and the Windows Server 2003 family | Yes, client included | Yes, stand-alone and domain DFS

Note

  • To support synchronization of targets, the referenced resource for a target must be located on a Windows Server 2003 family NTFS partition.


Using Distributed File System

This section covers:

  • Creating a DFS root
  • Adding a DFS root target
  • Adding a DFS link
  • Adding a target
  • Using File Replication Service
  • Checking target status
  • Managing DFS from the command line


Creating a DFS root

You can create a DFS root on an NTFS partition residing on a computer in the Windows Server 2003 family. When creating a DFS root, you have the option of establishing either a stand-alone DFS root or a domain DFS root.

A stand-alone DFS root:

  • Does not use Active Directory.
  • Cannot have more than one root-level target.
  • Does not support automatic file replication using the File Replication service.
  • Supports fault tolerance through Server clusters.

A domain DFS root:

  • Must be hosted on a domain member server.
  • Has its DFS namespace automatically published to Active Directory.
  • Can have more than one root-level target.
  • Supports automatic file replication through FRS.
  • Supports fault tolerance through FRS.

Using the DFS administration tool, you specify a target to assign as the DFS root. In addition to accessing this target, users can access any subfolders of this target.

You can host multiple DFS roots on a single computer when using XOX or XOX.

On server clusters, the name you give a non-clustered DFS root on a node's local storage must be different from the name you give a clustered DFS root on the cluster storage.

Large domain-based DFS namespaces might cause significantly increased network traffic due to the size of the DFS Active Directory object. As a result, it is recommended that you use fewer than 5,000 DFS links for a domain root. The largest recommended namespace size for a stand-alone root is 50,000 links on servers running Windows Server 2003.

If your DFS namespace includes roots and root targets which exist on both computers running one of the Windows Server 2003 family of products and computers running Windows 2000, you must administer those roots from a computer running a product in the Windows Server 2003 family, or from a computer running the Windows Server 2003 Administration Tools Pack. You can not administer the DFS namespace from a computer running Windows 2000.

For more information, see To create a DFS root.


Adding a DFS root target

Having more than one root target for a domain root helps ensure that if the host server becomes unavailable for any reason, the distributed file system associated with that DFS root is still available to domain users.

To add a root target, click the root and select New Root Target from the Action menu. This invokes the New Root Wizard.

Note

  • You can also delete a root target.


Adding a DFS link

A Distributed File System (DFS) link is an element in the DFS namespace that lies below the root and maps to one or more targets. Instead of seeing the target's actual name and physical location, users accessing a DFS namespace see the link name listed as a folder under the root. Because link names are not constrained by the target's name or location, you can create link names that are meaningful to the user. For example, you could create a link named "Marketing" that points to one or more targets that contain marketing information regardless of the actual name and location of those targets.

Large domain-based DFS namespaces might cause significantly increased network traffic due to the size of the DFS Active Directory object. As a result, it is recommended that you use fewer than 5,000 DFS links for a domain root. The largest recommended namespace size for a stand-alone root is 50,000 links on servers running Windows Server 2003.

For more information, see To add a DFS link.


Adding a target

For each DFS link, you can create a set of targets to which the DFS link points. Within a set of targets, you add the first folder to the set when you create the DFS link. Subsequent targets are added using the DFS administration tool's New Target dialog box.

Within a set of targets, you can choose which folders will participate in replication. If you add targets for domain DFS roots, you also need to do the following:

  • Set the replication policy among the targets.
  • Check the replication status.

For information on setting replication policy, see Using File Replication service.

For information on checking replication status, see Checking target status.


Using the File Replication service

This section covers:

  • Configuring replication topology
  • Configuring the replication schedule
  • Excluding files and folders from replication
  • Setting the initial synchronization priority for inbound connections


Configuring replication topology

The word "topology" typically refers to the relationship between components in a network. The replication topology describes the logical connections that FRS uses to replicate files between computers.

For each DFS root or DFS link, you can specify one of four basic topology types:

  • In a ring topology, files replicate from one computer to another in a circular configuration, with each computer connected to the computers on either side of it in the ring.
  • In a hub and spoke topology, one computer is designated as the hub and is connected to each of the other computers, called spokes. Files replicate from the hub computer to the spoke computers and vice versa, but files do not replicate directly between two spoke computers. You must choose which computer will serve as the hub.
  • In a full mesh topology, every computer is connected to every other computer. A file created on one computer replicates directly to all the others.
  • In a custom topology, you create the connections between computers yourself.
Replication topology types

When you select a topology, you can further customize it by selectively enabling or disabling the connections between computers. You can completely disable the relationship between two computers to prevent files from replicating between them at all, or you can make it one-way by disabling the connection from the first computer to the second while leaving the opposite connection available.

Many factors can affect the type of topology that is appropriate for your network, including bandwidth, security, geographic, and organizational considerations.

Note

  • Automatic file replication is available only for domain roots.


Configuring the replication schedule

When you first configure a /DFS root or a DFS link for replication, the File Replication service (FRS) schedules replication to take place around the clock. Whenever you copy a file to a target that participates in replication, FRS replicates the file to the other targets using the connections specified in the replication topology.

You might not want replication to take place automatically at certain times. For example, if certain servers are taken off the network every Friday evening from 9 to 11 for maintenance and restarting, you might want to halt replication to and from those servers at 9 on Friday and resume it two hours later. When a connection returns to replication, FRS immediately reconciles any differences between the two shares.

FRS lets you schedule the times when replication will or will not be available. You can modify the schedule for individual connections or for all connections at once. The Schedule dialog box displays the schedule for every hour in the week and lets you select blocks of time during which replication will or will not take place. Clicking the name of a weekday will select the entire day. Clicking a box at the top of the schedule to the right of the word All will select the same hour on every day throughout the week. Clicking All will select the entire schedule.

You can access the schedule in two ways. Clicking the Schedule button on the Replication tab of a root's or link's Properties sheet lets you view and change the schedule for all of the connections belonging to that root or link. If you select one or more connections in the Customize Topology dialog box and click the Schedule button, you can change the schedule for the selected connections only.

Notes

  • Automatic file replication through the File Replication service is only available with domain DFS.
  • Changing the schedule for all connections will overwrite any changes you have made to the schedule for individual connections.


Excluding files and folders from replication

Sometimes you may not want to replicate every file or subfolder contained within a DFS root or DFS link. For example, if a shared folder used as a target contains several temporary files created by applications for caching or record-keeping purposes, you might not want to replicate those files to all of the targets that participate in replication.

For each root and link, you can use the File Replication service to specify files and subfolders to exclude from replication. The exclusion rules apply to every target or root target designated as belonging to the selected root or link, and also apply to subfolders beneath the shared folders themselves.

You can use * and ? as wildcard characters when entering file or folder names. For example, *.tmp matches all files with the .tmp extension.

For specific instructions on excluding files and folders from replication, see:

  • To exclude files or subfolders from replication
  • To remove files or subfolders from the exclusion list

Note

  • Automatic file replication is only available for domain roots.


Setting the initial synchronization priority for inbound connections

It is often advantageous to control the sequence of synchronization during replication. Using Distributed File System (DFS) snap-in and the File Replication Service (FRS), you can configure synchronization priorities. You can determine which inbound connection will go first in the initial synchronization that occurs when you add a new member to a replica set or when you restore one of your replica set members. For example, you can adjust synchronization priorities to ensure that computers across a high-bandwidth network connection synchronize first, followed by synchronization with computers that are communicating through a lower-bandwidth connection. By adjusting the synchronization priorities, you can often reduce the time needed to perform the synchronization process.

Using FRS, you can choose from three synchronization priorities:

  • High: All connections marked High must successfully synchronize before a synchronization is attempted on Medium-priority connections.
  • Medium: At least one Medium priority connection must successfully complete an initial synchronization before any synchronization is attempted on Low-priority connections. FRS attempts to synchronize all connections in the Medium priority level, but only one must be successful before FRS attempts to synchronize Low priority connections.
  • Low: FRS attempts to synchronize with each computer on a Low priority connection one time, but any failure will not delay other synchronization attempts.

Low is the default synchronization priority for all connections. Typically, you should configure high-bandwidth or local connections to have a higher synchronization priority than low-bandwidth connections. Therefore, depending on the scenario, a priority of either Medium or High is appropriate for your local connections. However, be aware that if you have a High priority connection that fails, no other synchronization will take place.

The following two scenarios describe how you might use synchronization priorities:

  • Diagram showing the use of High and Low priorities. In the first example, you are using a hub and spoke topology. Computer X at a branch site fails and needs to be restored. Computer X has inbound connections from Computers A and B, which are located at a hub site. Computer X also has an inbound connection from Computer Y, which is located at the same branch site as Computer X. You should set the synchronization priority from Computer Y to Computer X to High. Set synchronization priorities from Computers A and B at the hub site to Computer X at the branch site to Low.

    The reason for these settings is that under normal conditions, you would not want to do a full synchronization over the slow link between Computer X and Computer A or Computer B. A synchronization from the hub site would take too long and consume all of the bandwidth of the slow link. Instead, the recovery of Computer X must occur first from the local Computer Y. Computer X can then try to synchronize from either Computer A or Computer B, but if communication problems prevent the synchronization, Computer X can still come online with the same content as Computer Y.

  • Diagram showing the use of Medium and Low priorities. For the second example, you are using a custom topology that consists of a two-level hub and spoke architecture. Computer A is at the hub site. The second level consists of Computers J, K, L, and M at the regional offices. At the bottom level are several departmental computers in branch offices.

    Computer A at the hub site has high bandwidth bi-directional connections to Computers J, K, L and M. At the regional offices, Computers J, K, L and M are connected in a medium bandwidth bi-directional ring. The branch office computers are each connected to two of the regional computers (J, K, L and M) by a low-bandwidth connection.

    Computers J, K, L and M are all expected to be up to date. Therefore, for Computer A, you should set the inbound connections from Computers J, K, L and M to Medium priority. You should also set the priority for the ring of connections between the regional office computers to Medium. The priority from the branch office computers to Computers J, K, L and M should be set to Low.

    Consider Computer K. Its inbound connections from A, J and L should all be set to Medium priority because a synchronization with any one of them would be sufficient for Computer K to come online. If the hub site (Computer A) is unavailable, Computers J, K, L and M can still complete a recovery without first synchronizing with Computer A. The justification for the Low priority from the branch office computers is the same as described in the first example.

Overriding the schedule for initial synchronization

Typically, synchronization will only take place at times defined in the synchronization schedule that you configure. However, you can override the schedule for initial synchronization or the initial creation of replica set member. By selecting the Override Schedule check box in the Priorities dialog box, you can cause the initial replication to occur immediately.

For more information on setting the priority, see To modify replication topology. For more information on setting the replication schedule, see To set the replication schedule.


Checking target status

You can check whether the targets that you have assigned are being referenced properly by DFS. The status check indicates one of the following conditions:

Checking status on a DFS root or DFS link will reveal one of the following icons:

  • A blue check mark on the root or link indicates that the root or link can be reached, and all of its targets can be reached.
  • A yellow exclamation point on the root or link indicates that the root or link can be reached, but not all of its targets can be reached, either because DFS referral is disabled on that target, or some other problem is preventing access to the target.
  • A red cross on the root or link indicates that the root or link cannot be reached.

Checking status on a target will result in the Status column in the details pane indicating Online or Offline. If the status of a target is Offline, that indicates that the target cannot be reached.


Managing DFS from the command line

You can use the dfscmd command-line utility to manage and configure DFS and DFS roots, links, and targets, and to write batch scripts so that other applications can interact with DFS. You can run the command-line utility from a command prompt by typing dfscmd.

For help using the DFS command line utility, see Dfscmd.

For information about other command-line utilities, see Command-line reference.